 /*
 
 Konvertiert eine n-Bit Binrzahl in eine gepackte m-Byte BCD-Zahl
 Der Speicherbereich von binaryvalue wird dabei leider auch berschrieben!
 
 destsize  : Anzahl Bytes in dest 1-256
 binarysize: Anzahl Bytes in binaryvalue 1-32

 extern void bigbin2bcd(char *dest, char *binaryvalue, unsigned char destsize, 
                      unsigned char binarysize);
 
 */
 
 #include <macros.inc>
 #include <ctoasm.inc>
 
 

 #define value 		r17
 #define temp 		r16
 #define destcounter	r21
 #define srccounter 	r21
 #define loopcounter 	r19
 
 #define dest_hi 	r25
 #define dest_lo 	r24
 #define binsrc_hi 	r23
 #define binsrc_lo 	r22
 #define destsize 	r20
 #define binarysize 	r18

 
    .global bigbin2bcd
    .func bigbin2bcd
 
 bigbin2bcd:               //  that's the beginning of the function
    
    // push...
    push r17
    push r16
    
    // init loopcounter
    mov loopcounter, binarysize
    lsl loopcounter 	// x2
    lsl loopcounter 	// x4
    lsl loopcounter 	// x8
    
    // clear dest
    LOAD_Z(dest_lo, dest_hi)
    ldi temp, 0
    mov destcounter, destsize
    
bbs1:    
    st Z+, temp	
    dec destcounter
    brne bbs1
    
bbsmainloop:    
    // happy shifting binaryvalue
    LOAD_X(binsrc_lo, binsrc_hi)
    LOAD_Z(dest_lo, dest_hi)
    mov	srccounter, binarysize
    clc
    
bbs2:    
    ld temp, X
    rol temp
    st X+, temp
    dec srccounter
    brne bbs2
    
    // happy shifting dest
    mov destcounter, destsize

bbs3:    
    ld temp, Z
    rol temp
    st Z+, temp
    dec destcounter
    brne bbs3
    
    // test loop counter
    dec loopcounter
    brne bbadd3	
    
// ****** Hier ist das Ende zwischen... ******
bbend:    
    // pop...
    pop r16
    pop r17

    ret                   // end of function, return to main program
 
// ****** Hier kommt die Add-3 Routine 
 
bbadd3:   	

    LOAD_Z(dest_lo, dest_hi)
    mov destcounter, destsize
    
bbadd3s:    
    ld value, Z

    mov temp, value
    subi temp, -0x03	// add 0x03
    // Ergebniss nur behalten, wenn nach der Addition Bit 3 gesetzt ist.
    sbrc temp, 3		
    mov value, temp	// Save, if Bit was set 
    
    mov temp, value 	
    subi temp, -0x30	// add 0x30
    // Ergebniss nur behalten, wenn nach der Addition Bit 7 gesetzt ist.
    sbrc temp, 7		
    mov value, temp	// Save, if Bit was set 
    
    st Z+, value
    
    dec destcounter
    brne bbadd3s
 
    rjmp bbsmainloop	
 
 
 
 
 
 
    .endfunc
 
